﻿// Серверный контекст настроек использования правок
//
// BSLLS:NestedFunctionInParameters-off - без лишних переменных выполнение быстрее
// BSLLS:EmptyRegion-off - пустые области разрешены

#Область ПрограммныйИнтерфейс

#КонецОбласти

#Область СлужебныйПрограммныйИнтерфейс

// Возвращает коллекцию настроек активности правок
//
// Параметры: 
//
// Возвращаемое значение: 
// 	Соответствие - Ключ идентификатор правки, Значение флаг использования
//
Функция Коллекция() Экспорт
	
	Результат	= Прочитать();
	Если НЕ исп_Конфигурация.Совместима() Тогда
		Коллекция	= Результат;
		Результат	= Новый Соответствие();
		Для Каждого Элемент Из Коллекция Цикл
			Результат.Вставить(Элемент.Ключ, Ложь);
		КонецЦикла;
	КонецЕсли;
	
	Возврат Новый ФиксированноеСоответствие(Результат);
	
КонецФункции // Коллекция 

// Истина, если доступно администрирование настроек
//
// Параметры: 
//
// Возвращаемое значение: 
// 	Булево
//
Функция АдминистрированиеДоступно() Экспорт
	
	Возврат ПравоДоступа("Администрирование", Метаданные);
	
КонецФункции // АдминистрированиеДоступно 

// Устанавливает флаг использования правки
//
// Параметры: 
// 	Идентификатор - Строка - Идентификатор правки
// 	Значение - Булево - Флаг использования
//
Процедура ПравкаИспользовать(Идентификатор, Значение) Экспорт
	
	Если НЕ ИзменениеРазрешено(Идентификатор) Тогда
		Возврат;
	КонецЕсли;
	
	Настройка	= Прочитать();
	Настройка.Вставить(Идентификатор, Значение);
	
	Сохранить(Настройка);
	
КонецПроцедуры // ПравкаИспользовать 

#КонецОбласти

#Область СлужебныеПроцедурыИФункции

// Сохраняет настройку в хранилище
//
// Параметры: 
// 	Настройка - Соответствие - Сохраняемая настройка
//
Процедура Сохранить(Настройка)
	
	ХранилищеСистемныхНастроек.Сохранить(ХранилищеОбъект()
	, ХранилищеНастройка()
	, Настройка
	, 
	, ХранилищеПользователь());
	
КонецПроцедуры // Сохранить 

// Возвращает сохраненную настройку
//
// Параметры: 
//
// Возвращаемое значение: 
// 	Соответствие
//
Функция Прочитать()
	
	УстановитьПривилегированныйРежим(Истина);
	
	Результат	= ХранилищеСистемныхНастроек.Загрузить(ХранилищеОбъект()
	, ХранилищеНастройка()
	, 
	, ХранилищеПользователь());
	
	Возврат ?(Результат = Неопределено, Новый Соответствие(), Результат);
	
КонецФункции // Прочитать 

// Возвращает идентификатор элемента хранилища системных настроек
//
// Параметры: 
//
// Возвращаемое значение: 
// 	Строка
//
Функция ХранилищеНастройка()
	
	Возврат "e2dc2003-e011-435e-a94f-32ecbc2e8e7b";
	
КонецФункции // ХранилищеНастройка 

// Возвращает ключ объекта элемента хранилища системных настроек
//
// Параметры: 
//
// Возвращаемое значение: 
// 	Строка
//
Функция ХранилищеОбъект()
	
	Возврат "bb3ddc5a-ad14-4d2c-9740-c6a1d23034a0";
	
КонецФункции // ХранилищеОбъект 

// Возвращает пользователя хранилища системных настроек
//
// Параметры: 
//
// Возвращаемое значение: 
// 	Строка
//
Функция ХранилищеПользователь()
	
	Возврат "add5e960-dd62-40c5-8c68-779277304700";
	
КонецФункции // ХранилищеПользователь 

// Истина, если изменение настроки правки разрешено
//
// Параметры: 
// 	Идентификатор - Строка - Идентификатор настройки
//
// Возвращаемое значение: 
// 	Булево
//
Функция ИзменениеРазрешено(Идентификатор)
	
	ИсключениеАдминистрированиеЗапрещено();
	ИсключениеПравкаОтсутствует(исп_Состав.Получить(), Идентификатор);
	
	Возврат Истина;
	
КонецФункции // ИзменениеРазрешено 

// Вызывает исключение при отсутствии права на администрирование
//
// Параметры: 
//
Процедура ИсключениеАдминистрированиеЗапрещено()
	
	Если НЕ исп_Настройка.АдминистрированиеДоступно() Тогда
		// BSLLS:Typo-off - опечатки нет
		ВызватьИсключение НСтр("ru = 'Администрирование запрещено! Обратитесь в техподдержку.'");
		// BSLLS:Typo-on
	КонецЕсли;
	
КонецПроцедуры // ИсключениеАдминистрированиеЗапрещено 

// Вызывает исполючение при изменении настроек отсутствующей правки
//
// Параметры: 
// 	Набор - Массив - Набор доступных правок
// 	Идентификатор - Строка - Идентификатор правки
//
Процедура ИсключениеПравкаОтсутствует(Набор, Идентификатор)
	
	Существует	= Ложь;
	
	Для Каждого Элемент Из Набор Цикл
		Если исп_Строка.ИменаРавны(Идентификатор, исп_Описание.Идентификатор(Элемент)) Тогда
			Существует	= Истина;
			Прервать;
		КонецЕсли;
	КонецЦикла;
	
	Если НЕ Существует Тогда
		ВызватьИсключение НСтр("ru = 'Попытка изменения настройки отсутствующей правки " + Идентификатор + "'");
	КонецЕсли;
	
КонецПроцедуры // ИсключениеПравкаОтсутствует 

#КонецОбласти

// BSLLS:NestedFunctionInParameters-on
// BSLLS:EmptyRegion-on
 